      program mesh
      include 'mpif.h'
      integer err,rank,size
      integer status(MPI_STATUS_SIZE)
      integer GRID,dim(2)
      logical period(2),reorder
      real sum
      integer nay(4),x,i,num,count
      integer hold(8)
      data hold/-27,-4,31,16,20,13,49,1/
      call MPI_INIT(err)
      call MPI_COMM_RANK(MPI_COMM_WORLD,rank,err)
      call MPI_COMM_SIZE(MPI_COMM_WORLD,size,err)
      x=hold(rank+1)
      dim(1)=2
      dim(2)=4
      period(1)=.false.
      period(2)=.false.
      reorder=.true.
      call MPI_CART_CREATE(MPI_COMM_WORLD,2,dim,period,reorder,GRID,err)
      call MPI_CART_SHIFT(GRID,0,1,nay(1),nay(2),err)
      call MPI_CART_SHIFT(GRID,1,1,nay(3),nay(4),err)
      do i=1,4
        if (nay(i) .ne. MPI_PROC_NULL) then
          call MPI_SEND(x,1,MPI_INTEGER,nay(i),66,MPI_COMM_WORLD,err)
        end if
      end do
      sum=1.0*x
      count=1
      do i=1,4
        if (nay(i) .ne. MPI_PROC_NULL) then
          call MPI_RECV(num,1,MPI_INTEGER,nay(i),66,
     &          MPI_COMM_WORLD,
     &           status,err)
          sum=sum+num
          count=count+1
        end if
      end do
      print *,"P:",rank,"my average is",sum/count
      call MPI_FINALIZE(err)
      end 
